=== debian/changelog ===
lager (0.1.0-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 05 Oct 2023 13:24:16 -0700

lager (0.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Ship the examples in liblager-dev.
  * Add libboost-dev, libimmer-dev, and libzug-dev as dependencies of
    liblager-dev.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Aug 2023 11:28:06 +0200

lager (0.1.0-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Fri, 28 Jul 2023 22:00:53 +0200
