=== example/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # ncurses examples
 # ================
 
-set(CMAKE_CURSES_NEED_WIDE true)
+set(CURSES_NEED_WIDE true)
 
 find_package(Curses)
 
@@ -63,11 +63,11 @@
     add_executable(counter-sdl2 EXCLUDE_FROM_ALL
       counter/sdl2/main.cpp)
     target_include_directories(counter-sdl2 SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(counter-sdl2
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples counter-sdl2)
 
@@ -75,11 +75,11 @@
       autopong/autopong.cpp
       autopong/sdl2/main.cpp)
     target_include_directories(autopong SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(autopong
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples autopong)
 
@@ -88,11 +88,11 @@
       autopong/sdl2/main.cpp)
     target_compile_definitions(autopong-debug PUBLIC DEBUGGER)
     target_include_directories(autopong-debug SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(autopong-debug
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples autopong-debug)
   endif()
@@ -120,7 +120,7 @@
   set_target_properties(todo-qml PROPERTIES AUTOMOC YES)
   target_link_libraries(todo-qml lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_compile_definitions(todo-qml PRIVATE
-    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml")
+    LAGER_TODO_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/todo/qml")
   add_dependencies(examples todo-qml)
 
   add_executable(todo-qml-redux EXCLUDE_FROM_ALL
@@ -131,7 +131,7 @@
   set_target_properties(todo-qml-redux PROPERTIES AUTOMOC YES)
   target_link_libraries(todo-qml-redux lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_compile_definitions(todo-qml-redux PRIVATE
-    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml-redux")
+    LAGER_TODO_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/todo/qml-redux")
   add_dependencies(examples todo-qml-redux)
 
   add_executable(snake-qml EXCLUDE_FROM_ALL
@@ -140,7 +140,7 @@
   target_link_libraries(snake-qml lager-example Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_include_directories(snake-qml PRIVATE ${Boost_INCLUDE_DIRS})
   target_compile_definitions(snake-qml PRIVATE
-    LAGER_SNAKE_QML_DIR="${CMAKE_SOURCE_DIR}/example/snake/qml")
+    LAGER_SNAKE_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/snake/qml")
   add_dependencies(examples snake-qml)
 else()
   message(STATUS "Disabling Qt based examples")
