=== debian/changelog ===
lager (0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Include-cstdint-for-std-uint32_t.patch: drop, backported from
      upstream
    - upstream_Fix-build-of-http_debug_server-with-boost-1.80.patch: drop,
      backported from upstream
  * Update the build dependencies according to the upstream build system:
    - add catch2
  * Update copyright.
  * Disable the tests for now: they assume Catch2 v2.x, and v3 requires changes.
  * Drop the manual search for ncurses and SDL2 in the 'build-examples'
    autopkgtest: the upstream CMakeLists.txt was fixed to properly search and
    use them.

 -- Pino Toscano <pino@debian.org>  Sun, 15 Oct 2023 21:17:09 +0200

lager (0.1.0-4) unstable; urgency=medium

  * Backport upstream commit ed62d99a1ed774f2b5a336684ee58e64e7c1f5c4 to support
    boost >= 1.80; patch
    upstream_Fix-build-of-http_debug_server-with-boost-1.80.patch.
  * Fix typo in the short description.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Oct 2023 08:37:53 +0200

lager (0.1.0-3) unstable; urgency=medium

  * Backport upstream commit 073c03acfdaf39f24ba2cd642743320979d53b6d to add
    a missing include in the SDL event loop; patch
    upstream_Include-cstdint-for-std-uint32_t.patch.
  * Add a 'build-examples' autopkgtest to build almost all the examples:
    ncurses, SDL2, Qt5.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Wed, 04 Oct 2023 21:03:35 +0200
