=== debian/rules ===
#!/usr/bin/make -f

# https://github.com/arximboldi/immer/issues/223
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-array-bounds

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -Dlager_BUILD_TESTS=OFF \
	  -Dlager_BUILD_EXAMPLES=OFF \
	  -Dlager_BUILD_DEBUGGER_EXAMPLES=OFF \
	  -Dlager_BUILD_DOCS=OFF

ifeq (disabledfornow,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif
