=== debian/tests/control ===
Tests: build-examples
Depends: build-essential, cmake, liblager-dev, libcereal-dev, libboost-dev, qtbase5-dev, qtdeclarative5-dev, qtquickcontrols2-5-dev, libncurses-dev, libsdl2-dev, libsdl2-ttf-dev
Restrictions: allow-stderr
