## lager 0.1.2

=== debian/changelog ===
lager (0.1.2-2) unstable; urgency=medium

  * Stop using Boost::system: (Closes: #1127219)
    - backport upstream commit 0eb1d3d3a6057723c5b57b3e0ee3e41924ff419a;
      patch upstream_Stop-using-Boost-system.patch
    - drop the libboost-system-dev build dependency

 -- Pino Toscano <pino@debian.org>  Fri, 13 Feb 2026 05:01:21 +0100

lager (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.10
  * Update the patches:
    - Switch-from-boost-asio-io_service-to-io_context.diff: drop, fixed upstream

 -- Pino Toscano <pino@debian.org>  Tue, 20 Jan 2026 06:40:30 +0100

lager (0.1.1-3) unstable; urgency=medium

  * Backport the upstream PR https://github.com/arximboldi/lager/pull/227 to
    switch from boost::asio::io_service to io_context, as the former is a long
    deprecated alias, removed in newer versions of boost. (Closes: #1110833)

 -- Pino Toscano <pino@debian.org>  Sun, 21 Dec 2025 09:44:45 +0100

lager (0.1.1-2) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Disable the build of the debugger examples in the 'build-examples'
    autopkgtest: counter-ncurses-tree fails to build with immer 0.9.0:
    https://github.com/arximboldi/lager/issues/228

 -- Pino Toscano <pino@debian.org>  Mon, 15 Dec 2025 22:39:58 +0100
