=== debian/control ===
Source: lager
Section: libs
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: catch2,
               cmake (>= 3.10~),
               debhelper-compat (= 13),
               libboost-dev (>= 1.56~),
               libcereal-dev <!nocheck>,
               libimmer-dev,
               libzug-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/arximboldi/lager
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lager
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lager.git

Package: liblager-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libboost-dev,
         libimmer-dev,
         libzug-dev,
Description: C++ library for value-oriented design -- development files
 lager is a C++ library to assist value-oriented design by implementing the
 unidirectional data-flow architecture. It is heavily inspired by Elm and Redux,
 and enables composable designs by promoting the use of simple value types and
 testable application logic via pure functions. And you get time-travel for
 free!
 .
 This package contains the development files.
