=== debian/changelog ===
lager (0.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Stop-using-Boost-system.patch: drop, backported from upstream

 -- Pino Toscano <pino@debian.org>  Thu, 26 Feb 2026 20:11:17 +0100
